0N/A#!/bin/ksh -p
0N/A
0N/A#
2362N/A# Copyright (c) 2002, 2006, Oracle and/or its affiliates. All rights reserved.
0N/A# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
0N/A#
0N/A# This code is free software; you can redistribute it and/or modify it
0N/A# under the terms of the GNU General Public License version 2 only, as
0N/A# published by the Free Software Foundation.
0N/A#
0N/A# This code is distributed in the hope that it will be useful, but WITHOUT
0N/A# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
0N/A# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
0N/A# version 2 for more details (a copy is included in the LICENSE file that
0N/A# accompanied this code).
0N/A#
0N/A# You should have received a copy of the GNU General Public License version
0N/A# 2 along with this work; if not, write to the Free Software Foundation,
0N/A# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
0N/A#
2362N/A# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
2362N/A# or visit www.oracle.com if you need additional information or have any
2362N/A# questions.
0N/A#
0N/A
0N/A#
0N/A# @test JITDebug.sh 1.7 03/09/05
0N/A# @bug 4291701 4376819 4422312 4522770 4913748
0N/A# @summary Test JIT debugging - assure that launching on
0N/A# uncaught exception works
0N/A# @author Tim Bell
0N/A# Based on test/java/awt/TEMPLATE/AutomaticShellTest.sh
0N/A#
0N/A# @run build TestScaffold VMConnection TargetListener TargetAdapter
0N/A# @run compile -g JITDebug.java
0N/A# @run shell JITDebug.sh
0N/A
0N/A# Beginning of subroutines:
0N/Astatus=1
0N/A
0N/A#Call this from anywhere to fail the test with an error message
0N/A# usage: fail "reason why the test failed"
4638N/Afail()
0N/A { echo "The test failed :-("
0N/A echo "$*" 1>&2
0N/A echo "exit status was $status"
0N/A exit $status
0N/A } #end of fail()
0N/A
0N/A#Call this from anywhere to pass the test with a message
0N/A# usage: pass "reason why the test passed if applicable"
4638N/Apass()
0N/A { echo "The test passed!!!"
0N/A echo "$*" 1>&2
0N/A exit 0
0N/A } #end of pass()
0N/A
0N/A# end of subroutines
0N/A
0N/A
0N/A# The beginning of the script proper
0N/A
0N/AOS=`uname -s`
0N/Aexport TRANSPORT_METHOD
0N/Acase "$OS" in
4638N/A SunOS | Linux | Darwin )
0N/A PATHSEP=":"
0N/A TRANSPORT_METHOD=dt_socket
0N/A ;;
0N/A
0N/A Windows* | CYGWIN*)
0N/A PATHSEP=";"
0N/A TRANSPORT_METHOD=dt_shmem
0N/A ;;
0N/A
0N/A # catch all other OSs
0N/A * )
0N/A echo "Unrecognized system! $OS"
0N/A fail "Unrecognized system! $OS"
0N/A ;;
0N/Aesac
0N/A#
4638N/A# Want this test to run standalone as well as in the harness, so do the
4638N/A# following to copy the test's directory into the harness's scratch directory
0N/A# and set all appropriate variables:
0N/A
0N/Aif [ -z "${TESTJAVA}" ] ; then
0N/A # TESTJAVA is not set, so the test is running stand-alone.
0N/A # TESTJAVA holds the path to the root directory of the build of the JDK
0N/A # to be tested. That is, any java files run explicitly in this shell
0N/A # should use TESTJAVA in the path to the java interpreter.
0N/A # So, we'll set this to the JDK spec'd on the command line. If none
0N/A # is given on the command line, tell the user that and use a default.
0N/A # THIS IS THE JDK BEING TESTED.
0N/A if [ -n "$1" ] ; then
0N/A TESTJAVA=$1
0N/A else
4638N/A TESTJAVA=$JAVA_HOME
0N/A fi
0N/A TESTSRC=.
0N/A TESTCLASSES=.
0N/A #Deal with .class files:
0N/A #if running standalone (no test harness of any kind), compile the
0N/A #support files and the test case
0N/A ${TESTJAVA}/bin/javac -d ${TESTCLASSES} \
1940N/A -classpath "$TESTJAVA/lib/tools.jar${PATHSEP}${TESTSRC}" \
0N/A TestScaffold.java VMConnection.java TargetListener.java TargetAdapter.java
0N/A ${TESTJAVA}/bin/javac -d ${TESTCLASSES} \
1940N/A -classpath "$TESTJAVA/lib/tools.jar${PATHSEP}${TESTSRC}" -g \
0N/A JITDebug.java
0N/Afi
0N/Aecho "JDK under test is: $TESTJAVA"
0N/A#
0N/ACLASSPATH="$TESTJAVA/lib/tools.jar${PATHSEP}${TESTCLASSES}"
0N/Aexport CLASSPATH
0N/ACP="-classpath \"${CLASSPATH}\""
0N/A#
0N/ATARGETCLASS=JITDebug
0N/ARUNFLAGS='-showversion -DTRANSPORT_METHOD="${TRANSPORT_METHOD}"'
0N/ARUNFLAGS="-Dtest.classes=${TESTCLASSES} ${RUNFLAGS}"
0N/A#
0N/Aecho ""
0N/Aecho "Environment variable definitions are:"
0N/Aecho ""
0N/Aenv | sort
0N/Aecho ""
0N/Aecho ""
0N/A#
0N/Aecho "Starting test:"
0N/Aecho ${TESTJAVA}/bin/java -DHANGINGJAVA_DEB ${RUNFLAGS} ${CP} ${TARGETCLASS}
0N/Aeval ${TESTJAVA}/bin/java -DHANGINGJAVA_DEB ${RUNFLAGS} ${CP} ${TARGETCLASS}
0N/Astatus=$?
0N/Aif [ $status -ne "0" ];
0N/Athen fail "test failed for class=$TARGETCLASS!"
0N/Afi
0N/A#
0N/A# pass or fail the test based on status of the command
0N/Aif [ $status -eq "0" ];
0N/A then pass ""
0N/A
0N/A else fail "unspecified test failure"
0N/Afi